include "../Address/ServerInterface.iol"
include "../Age/ServerInterface2.iol"
include "ComposerInterface.iol"

include "console.iol"

include "config.iol"

execution{ concurrent }

outputPort Server {
	Location: ServerLocation
	Protocol: sodep
	Interfaces: ServerInterface
}

outputPort Server2 {
	Location: Server2Location
	Protocol: sodep
	Interfaces: Server2Interface
}

include "deploy.iol"

main {
	getInfo( request )( response ) {
		{
			scope( main ) {
				install( IOException => comp( age_scope ) ; comp( address_scope ) );								
				scope( address_scope ) {
					install( this => resp_address.address = "undefined_compensated" );
					install( PersonNotFound => resp_address.address = "undefined");
					getAddress@Server( request )( resp_address )				
				}
				|
				scope( age_scope ) {
					install( this => resp_age.age = -1 );
					getAge@Server2( request )( resp_age );
					install( this => nullProcess )
				}
			}
		}
		;
		response.address = resp_address.address;
		response.age = resp_age.age
	}
}