include "database.iol"
include "console.iol"

include "AddressServerInterface.iol"

execution{ concurrent }


include "deploy.iol"

init {
    with( connectionInfo ) {        
	    .host = "localhost"; 
	    .driver = "postgresql";
	    .port = 5432;
	    .database= "sample"; 
	    .username = "postgres";
	    .password = "postgres"
    };	
    connect@Database( connectionInfo )();
    println@Console("DB connected, connection is running on host:" + connectionInfo.host )()
}

main {
	getAddress( request )( response ) {		
		q = "SELECT * FROM people WHERE name=:name AND surname=:surname";
		q.name = request.name;
		q.surname = request.surname;
		query@Database( q )( result );

		if ( #result.row == 0 ) {
			throw( PersonDoesNotExist )
		} else {
			response.address = result.row[ 0 ].address
		}
	}

}

